#include <I2S.h>

int sampleRateForI2S = 31250; // (48 MHz / sampleRate) must be a multiple of 64
volatile int available = 0;
uint8_t buffer[512];
uint8_t bufferSafe[512];

void setup() {

  pinMode(LED_BUILTIN, OUTPUT);

  Serial1.begin(115200);
  I2S.onReceive(onI2SReceive);

    if (!I2S.begin(I2S_PHILIPS_MODE, sampleRateForI2S, 32))
    {
        Serial1.println("Failed to initialize I2S!");
        while (1);
    }

    I2S.read(); // Start I2S

}


void onI2SReceive()
{

    I2S.read(buffer, 512); 
    if (available==0) memcpy(&bufferSafe[0],&buffer[0],sizeof(buffer));
    available = 1;

    digitalWrite(LED_BUILTIN, HIGH);
}


void loop() {
 
 if (available==1)
 {

  // for binary use: Serial1.write(buffer,512);

  for (int i = 0; i < 64; i++) 
  {
    int sampleVal=(bufferSafe[i*8+4]<<0) | (bufferSafe[i*8+5]<<8) | (bufferSafe[i*8+6]<<16) | (bufferSafe[i*8+7]<<24);
    Serial1.println(sampleVal);
  }

  digitalWrite(LED_BUILTIN, LOW);
  available=0;
  
 }

}
